libdap::Vector Class Referenceabstract

Holds a one-dimensional collection of DAP2 data types. More...

`#include <Vector.h>`

Inheritance diagram for libdap::Vector:

## Public Types

typedef stack< BaseType * > | btp_stack

## Public Member Functions

void | add_var (BaseType *v, Part p=nil) override
| Add the BaseType pointer to this constructor type instance.
void | add_var_nocopy (BaseType *v, Part p=nil) override
unsigned int | buf2val (void **val) override
| Copies data from the Vector buffer.
uint64_t | buf2val_ll (void **val)
bool | check_semantics (string &msg, bool all=false) override
| Compare an object's current state with the semantics of its type.
void | clear_local_data () override
void | compute_checksum (Crc32 &checksum) override
| include the data for this variable in the checksum DAP4 includes a checksum with every data response. This method adds the variable's data to that checksum.
virtual bool | d4_ops (BaseType *b, int op)
| Evaluator a relop for DAP4.
virtual string | dataset () const
| Returns the name of the dataset used to create this instance.
void | deserialize (D4StreamUnMarshaller &um, DMR &dmr) override
bool | deserialize (UnMarshaller &um, DDS *dds, bool reuse=false) override
| Receive data from the net.
void | dump (ostream &strm) const override
| dumps information about this object
int | element_count (bool leaves) override
| Count the members of constructor types.
virtual std::string | FQN () const
virtual BaseType * | get_ancestor ()
virtual AttrTable & | get_attr_table ()
char * | get_buf ()
vector< BaseType * > & | get_compound_buf ()
virtual BaseType * | get_parent () const
vector< string > & | get_str ()
virtual unsigned int | get_value_capacity () const
virtual uint64_t | get_value_capacity_ll () const
void | intern_data () override
| Read data into this variable.
void | intern_data (ConstraintEvaluator &eval, DDS &dds) override
| read data into a variable for later use
virtual bool | is_constructor_type () const
| Returns true if the instance is a constructor (i.e., Structure, Sequence or Grid) type variable.
virtual bool | is_dap4 () const
bool | is_dap4_projected (std::vector< std::string > &projected_dap4_inventory) override
virtual bool | is_in_selection ()
| Is this variable part of the current selection?
virtual bool | is_simple_type () const
| Returns true if the instance is a numeric, string or URL type variable.
virtual bool | is_vector_type () const
| Returns true if the instance is a vector (i.e., array) type variable.
int | length () const override
| Returns the number of elements in the vector. Note that some child classes of Vector use the length of -1 as a flag value.
int64_t | length_ll () const override
| Get the number of elements in this Vector/Array This version of the function deprecates length() which is limited to 32-bit sizes. The field uses -1 as a sentinel value indicating that the Vector/Array holds no values yet (as opposed to zero values).
virtual string | name () const
| Returns the name of the class instance.
Vector & | operator= (const Vector &rhs)
virtual bool | ops (BaseType *b, int op)
| Evaluate relational operators.
virtual void | print_dap4 (XMLWriter &xml, bool constrained=false)
virtual void | print_decl (FILE *out, string space=" ", bool print_semi=true, bool constraint_info=false, bool constrained=false)
| Print an ASCII representation of the variable structure.
virtual void | print_decl (ostream &out, string space=" ", bool print_semi=true, bool constraint_info=false, bool constrained=false)
| Print an ASCII representation of the variable structure.
virtual void | print_xml (FILE *out, string space=" ", bool constrained=false)
virtual void | print_xml (ostream &out, string space=" ", bool constrained=false)
virtual void | print_xml_writer (XMLWriter &xml, bool constrained=false)
virtual BaseType * | prototype () const
virtual BaseType * | ptr_duplicate ()=0
virtual bool | read ()
| Read data into a local buffer.
virtual bool | read_p ()
| Has this variable been read?
virtual void | reserve_value_capacity ()
virtual void | reserve_value_capacity (unsigned int numElements)
virtual void | reserve_value_capacity_ll ()
virtual void | reserve_value_capacity_ll (uint64_t numElements)
virtual void | reserve_value_capacity_ll_byte (uint64_t numBytes)
virtual bool | send_p ()
| Should this variable be sent?
bool | serialize (ConstraintEvaluator &eval, DDS &dds, Marshaller &m, bool ce_eval=true) override
| Serialize a Vector.
void | serialize (D4StreamMarshaller &m, DMR &dmr, bool filter=false) override
| The DAP4 serialization method. Serialize a variable's values for DAP4. This does not write the DMR persistent representation but does write that part of the binary data blob that holds a variable's data. Once a variable's data are serialized, that memory is reclaimed (by calling BaseType::clear_local_data())
virtual void | set_attr_table (const AttrTable &at)
virtual void | set_in_selection (bool state)
virtual void | set_is_dap4 (const bool v)
void | set_length (int64_t l) override
| Sets the length of the vector. This function does not allocate any new space.
void | set_length_ll (int64_t l) override
| Set the number of elements in this Vector/Array This version of the function deprecates set_length() which is limited to 32-bit sizes. The field uses -1 as a sentinel value indicating that the Vector/Array holds no values.
void | set_name (const std::string &name) override
| Sets the name of the class instance.
virtual void | set_parent (BaseType *parent)
virtual BaseType * | set_prototype (BaseType *btp)
| Change the Vector/Array element type.
void | set_read_p (bool state) override
| Indicates that the data is ready to send.
void | set_send_p (bool state) override
| Indicates that the data is ready to send.
virtual void | set_synthesized_p (bool state)
virtual void | set_type (const Type &t)
| Sets the type of the class instance.
virtual bool | set_value (dods_byte *val, int sz)
virtual bool | set_value (dods_float32 *val, int sz)
virtual bool | set_value (dods_float64 *val, int sz)
virtual bool | set_value (dods_int16 *val, int sz)
virtual bool | set_value (dods_int32 *val, int sz)
virtual bool | set_value (dods_int64 *val, int sz)
virtual bool | set_value (dods_int8 *val, int sz)
virtual bool | set_value (dods_uint16 *val, int sz)
virtual bool | set_value (dods_uint32 *val, int sz)
virtual bool | set_value (dods_uint64 *val, int sz)
virtual bool | set_value (string *val, int sz)
| set the value of a string or url array
virtual bool | set_value (vector< dods_byte > &val, int sz)
virtual bool | set_value (vector< dods_float32 > &val, int sz)
virtual bool | set_value (vector< dods_float64 > &val, int sz)
virtual bool | set_value (vector< dods_int16 > &val, int sz)
virtual bool | set_value (vector< dods_int32 > &val, int sz)
virtual bool | set_value (vector< dods_int64 > &val, int sz)
virtual bool | set_value (vector< dods_int8 > &val, int sz)
virtual bool | set_value (vector< dods_uint16 > &val, int sz)
virtual bool | set_value (vector< dods_uint32 > &val, int sz)
virtual bool | set_value (vector< dods_uint64 > &val, int sz)
virtual bool | set_value (vector< string > &val, int sz)
| set the value of a string or url array
void | set_value_capacity (uint64_t l)
virtual bool | set_value_ll (dods_byte *val, int64_t sz)
virtual bool | set_value_ll (dods_float32 *val, int64_t sz)
virtual bool | set_value_ll (dods_float64 *val, int64_t sz)
virtual bool | set_value_ll (dods_int16 *val, int64_t sz)
virtual bool | set_value_ll (dods_int32 *val, int64_t sz)
virtual bool | set_value_ll (dods_int64 *val, int64_t sz)
virtual bool | set_value_ll (dods_int8 *val, int64_t sz)
virtual bool | set_value_ll (dods_uint16 *val, int64_t sz)
virtual bool | set_value_ll (dods_uint32 *val, int64_t sz)
virtual bool | set_value_ll (dods_uint64 *val, int64_t sz)
virtual bool | set_value_ll (string *val, int64_t sz)
virtual bool | set_value_ll (vector< dods_byte > &val, int64_t sz)
virtual bool | set_value_ll (vector< dods_float32 > &val, int64_t sz)
virtual bool | set_value_ll (vector< dods_float64 > &val, int64_t sz)
virtual bool | set_value_ll (vector< dods_int16 > &val, int64_t sz)
virtual bool | set_value_ll (vector< dods_int32 > &val, int64_t sz)
virtual bool | set_value_ll (vector< dods_int64 > &val, int64_t sz)
virtual bool | set_value_ll (vector< dods_int8 > &val, int64_t sz)
virtual bool | set_value_ll (vector< dods_uint16 > &val, int64_t sz)
virtual bool | set_value_ll (vector< dods_uint32 > &val, int64_t sz)
virtual bool | set_value_ll (vector< dods_uint64 > &val, int64_t sz)
virtual bool | set_value_ll (vector< string > &val, int64_t sz)
virtual uint64_t | set_value_slice_from_row_major_vector (const Vector &rowMajorData, uint64_t startElement)
void | set_vec (unsigned int i, BaseType *val)
| Sets element i to value val.
void | set_vec_ll (uint64_t i, BaseType *val)
void | set_vec_nocopy (unsigned int i, BaseType *val)
| Sets element i to value val. Set the ith element to val. Extend the vector if needed.
void | set_vec_nocopy_ll (uint64_t i, BaseType *val)
virtual bool | synthesized_p ()
virtual string | toString ()
virtual void | transfer_attributes (AttrTable *at)
virtual std::vector< BaseType * > * | transform_to_dap2 (AttrTable *parent_attr_table)
| DAP4 to DAP2 transform.
virtual void | transform_to_dap4 (D4Group *root, Constructor *container)
| DAP2 to DAP4 transform.
virtual Type | type () const
| Returns the type of the class instance.
virtual string | type_name () const
| Returns the type of the class instance as a string.
unsigned int | val2buf (void *val, bool reuse=false) override
| Reads data into the Vector buffer.
uint64_t | val2buf_ll (void *val, bool reuse=false)
virtual void * | value ()
virtual void | value (dods_byte *b) const
virtual void | value (dods_float32 *b) const
virtual void | value (dods_float64 *b) const
virtual void | value (dods_int16 *b) const
virtual void | value (dods_int32 *b) const
virtual void | value (dods_int64 *b) const
virtual void | value (dods_int8 *b) const
virtual void | value (dods_uint16 *b) const
virtual void | value (dods_uint32 *b) const
virtual void | value (dods_uint64 *b) const
virtual void | value (vector< string > &b) const
| Get a copy of the data held by this variable.
virtual void | value (vector< unsigned int > *index, vector< string > &b) const
| Get a copy of the data held by this variable using the passed subsetIndex vector to identify which values to return.
virtual void | value (vector< unsigned int > *indices, dods_byte *b) const
virtual void | value (vector< unsigned int > *indices, dods_float32 *b) const
virtual void | value (vector< unsigned int > *indices, dods_float64 *b) const
virtual void | value (vector< unsigned int > *indices, dods_int16 *b) const
virtual void | value (vector< unsigned int > *indices, dods_int32 *b) const
virtual void | value (vector< unsigned int > *indices, dods_int64 *b) const
virtual void | value (vector< unsigned int > *indices, dods_int8 *b) const
virtual void | value (vector< unsigned int > *indices, dods_uint16 *b) const
virtual void | value (vector< unsigned int > *indices, dods_uint32 *b) const
virtual void | value (vector< unsigned int > *indices, dods_uint64 *b) const
virtual void | value_ll (vector< uint64_t > *index, vector< string > &b) const
virtual void | value_ll (vector< uint64_t > *indices, dods_byte *b) const
virtual void | value_ll (vector< uint64_t > *indices, dods_float32 *b) const
virtual void | value_ll (vector< uint64_t > *indices, dods_float64 *b) const
virtual void | value_ll (vector< uint64_t > *indices, dods_int16 *b) const
virtual void | value_ll (vector< uint64_t > *indices, dods_int32 *b) const
virtual void | value_ll (vector< uint64_t > *indices, dods_int64 *b) const
virtual void | value_ll (vector< uint64_t > *indices, dods_int8 *b) const
virtual void | value_ll (vector< uint64_t > *indices, dods_uint16 *b) const
virtual void | value_ll (vector< uint64_t > *indices, dods_uint32 *b) const
virtual void | value_ll (vector< uint64_t > *indices, dods_uint64 *b) const
BaseType * | var (const string &name, btp_stack &s) override
BaseType * | var (const string &name="", bool exact_match=true, btp_stack *s=nullptr) override
virtual BaseType * | var (unsigned int i)
virtual BaseType * | var_ll (uint64_t i)
void | vec_resize (int l)
void | vec_resize_ll (int64_t l)
| Vector (const string &n, BaseType *v, const Type &t, bool is_dap4=false)
| The Vector constructor.
| Vector (const string &n, const string &d, BaseType *v, const Type &t, bool is_dap4=false)
| The Vector constructor.
| Vector (const Vector &rhs)
unsigned int | width (bool constrained=false) const override
| Returns the width of the data, in bytes.
int64_t | width_ll (bool constrained=false) const override
| Return the number of bytes needed to hold the array data.
virtual D4Attributes * | attributes ()
virtual void | set_attributes (D4Attributes *)
virtual void | set_attributes_nocopy (D4Attributes *)
Abstract Methods
virtual void | print_val (FILE *out, string space="", bool print_decl_p=true)
| Prints the value of the variable.
virtual void | print_val (ostream &out, string space="", bool print_decl_p=true)=0
| Prints the value of the variable.

## Protected Member Functions

void | m_duplicate (const BaseType &bt)
| Perform a deep copy.

## Friends

class | MarshallerTest
| Conditionally set to true in set_length_ll()

## Detailed Description

Holds a one-dimensional collection of DAP2 data types.

Holds a one-dimensional array of DAP2 data types. This class takes two forms, depending on whether the elements of the vector are themselves simple or compound objects. This class contains common functionality for the List and Array classes, and should rarely be used directly.

When each element of the class is a simple data type, the Vector is implemented as a simple array of C types, rather than as an array of BaseType data types. A single private `‘template’' BaseType instance (`_var`) is used to hold information in common to all the members of the array. The template is also used as a container to pass values back and forth to an application program, as in `var()`.

If the elements of the vector are themselves compound data types, the array is stored as a vector of BaseType pointers (see the libdap class BaseTypePtrVec). The template is still used to hold information in common to all the members of the array, but is not used to pass information to and from the application program.

See also
  BaseType
  Array

Definition at line 82 of file Vector.h.

## Member Typedef Documentation

## btp_stack

typedef stack<BaseType *> libdap::BaseType::btp_stack

inherited

Definition at line 151 of file BaseType.h.

## Constructor & Destructor Documentation

## Vector() [1/3]

libdap::Vector::Vector | ( | const string & | n,
|  | BaseType * | v,
|  | const Type & | t,
|  | bool | is_dap4 = `false`
| ) |  |

The Vector constructor.

The Vector constructor requires the name of the variable to be created, and a pointer to an object of the type the Vector is to hold. The name may be omitted, which will create a nameless variable. The template object may not be omitted.

Parameters

  n | A string containing the name of the variable to be created.
  v | A pointer to a prototype for elements.
  t | The type of the resulting Vector object, from the Type enum list. There is no DAP2 Vector object, so all uses of this method will be from the Array class. This defaults to `dods_null_c`.

See also
  Type

Definition at line 259 of file Vector.cc.

## Vector() [2/3]

libdap::Vector::Vector | ( | const string & | n,
|  | const string & | d,
|  | BaseType * | v,
|  | const Type & | t,
|  | bool | is_dap4 = `false`
| ) |  |

The Vector constructor.

The Vector server-side constructor requires the name of the variable to be created, the dataset name from which this Vector is created, and a pointer to an object of the type the Vector is to hold. The name may be omitted, which will create a nameless variable. The template object may not be omitted.

Parameters

  n | A string containing the name of the variable to be created.
  d | A string containing the dataset name from which the variable is being created.
  v | A pointer to a prototype for elements.
  t | The type of the resulting Vector object, from the Type enum list. There is no DAP2 Vector object, so all uses of this method will be from the Array class. This defaults to `dods_null_c`.

See also
  Type

Definition at line 288 of file Vector.cc.

## Vector() [3/3]

libdap::Vector::Vector | ( | const Vector & | rhs | ) |

The Vector copy constructor.

Definition at line 300 of file Vector.cc.

## ~Vector()

libdap::Vector::~Vector | ( |  | ) |

virtual

Definition at line 309 of file Vector.cc.

## Member Function Documentation

## add_var()

void libdap::Vector::add_var | ( | BaseType * | v,
|  | Part | p = `nil`
| ) |  |

override virtual

Add the BaseType pointer to this constructor type instance.

Propagate the name of the BaseType instance to this instance. This ensures that variables at any given level of the DDS table have unique names (i.e., that Arrays do not have their default name ""). If `v`'s name is null, then assume that the array is named and don't overwrite it with `v`'s null name.

Note
  As is the case with Array, this method can be called with a null BaseType pointer.

Parameters

  v | The template variable for the array
  p | The Part parameter defaults to nil and is ignored by this method.

Reimplemented from libdap::BaseType.

Definition at line 2552 of file Vector.cc.

## add_var_nocopy()

void libdap::Vector::add_var_nocopy | ( | BaseType * | v,
|  | Part | p = `nil`
| ) |  |

override virtual

Reimplemented from libdap::BaseType.

Definition at line 2594 of file Vector.cc.

## attributes()

D4Attributes * libdap::BaseType::attributes | ( |  | ) |

virtual inherited

DAP4 Attribute methods

Definition at line 596 of file BaseType.cc.

## buf2val()

unsigned int libdap::Vector::buf2val | ( | void ** | val | ) |

override virtual

Copies data from the Vector buffer.

Copy data from a numeric or string arry to a buffer. This method will allocate memory if the handle `val` references NULL, otherwise it assumes the handle references enough storage for the data to be copied.

Never call this method for constructor types Structure, Sequence or Grid.

When reading data out of a variable that has been constrained, this method assumes the N values/bytes of constrained data start at the beginning of the object's internal buffer. For example, do not load an entire Vector's data using val2buf(), constrain and then use this method to get the data. Unless your constraint starts with the [0]th element, the result will not be the correct values.

In the case of a Vector of Str objects, this method will return a pointer to an array of C++ std::string objects.

Note
  It's best to define the pointer to reference the data as 'char *data' or some other non-void type and then call this method using '..->buf2val((void**)&data)'. You must free the storage once you're done using 'delete[] data'.
  It's also important to initialize the handle to NULL. That is your code should declare the handle like this: 'char *data = 0' if it expects buf2val() to allocate memory. With most compilers, the pointer may be null the first time the code is run, but often not on subsequent calls.

Returns
  The number of bytes used to store the array.

Parameters

  val | A pointer to a pointer to the memory into which the class data will be copied. If the value pointed to is NULL, memory will be allocated to hold the data, and the pointer value modified accordingly. The calling program is responsible for deallocating the memory indicated by this pointer.

Exceptions

  InternalErr | Thrown if val is null.

See also
  Vector::set_vec

Implements libdap::BaseType.

Definition at line 1452 of file Vector.cc.

## buf2val_ll()

uint64_t libdap::Vector::buf2val_ll | ( | void ** | val | ) |

Definition at line 1508 of file Vector.cc.

## check_semantics()

bool libdap::Vector::check_semantics | ( | string & | msg,
|  | bool | all = `false`
| ) |  |

override virtual

Compare an object's current state with the semantics of its type.

This function checks the class instance for internal consistency. This is important to check for complex constructor classes. For BaseType, an object is semantically correct if it has both a non-null name and type.

For example, an Int32 instance would return FALSE if it had no name or no type defined. A Grid instance might return FALSE for more complex reasons, such as having Map arrays of the wrong size or shape.

This function is used by the DDS class, and will rarely, if ever, be explicitly called by a DODS application program. A variable must pass this test before it is sent, but there may be many other stages in a retrieve operation where it would fail.

Returns
  Returns FALSE when the current state violates some aspect of the type semantics, TRUE otherwise.

Parameters

  msg | A returned string, containing a message indicating the source of any problem.
  all | For complex constructor types (Grid, Sequence, Structure), this flag indicates whether to check the semantics of the member variables, too.

See also
  DDS::check_semantics

Reimplemented from libdap::BaseType.

Definition at line 2619 of file Vector.cc.

## clear_local_data()

void libdap::Vector::clear_local_data | ( |  | ) |

override virtual

Remove any read or set data in the private data of this Vector, setting read_p() to false. Essentially clears the _buf, d_str, and d_compound_buf of any data. Useful for tightening up memory when the data are no longer needed, but the object cannot yet be destroyed.

On exit: get_value_capacity() == 0 && !read_p()

Reimplemented from libdap::BaseType.

Definition at line 1672 of file Vector.cc.

## compute_checksum()

void libdap::Vector::compute_checksum | ( | Crc32 & | checksum | ) |

override virtual

include the data for this variable in the checksum DAP4 includes a checksum with every data response. This method adds the variable's data to that checksum.

Parameters

  checksum | A Crc32 instance that holds the current checksum.

Implements libdap::BaseType.

Definition at line 959 of file Vector.cc.

## d4_ops()

bool libdap::BaseType::d4_ops | ( | BaseType * | b,
|  | int | op
| ) |  |

virtual inherited

Evaluator a relop for DAP4.

This method is used by the filter expression evaluation code in DAP4. Each of the 'data type' classes that support relops must overload this method. In an expression of the form arg1 op arg2, this object is arg1, the parameter 'b' is arg2 and op is the relational operator.

Note
  I used the same relop codes for DAP4 as in the DAP2 parser/scanner which makes for some coupling between them, but cuts way down on the duplication of the evaluator logic, which is somewhat involved.

Parameters

  b | The second argument in the relational expression
  op | The infix relational operator

Returns
  True if the expression is true, False otherwise.

Reimplemented in libdap::Byte, libdap::Float32, libdap::Float64, libdap::Int16, libdap::Int32, libdap::Int64, libdap::Int8, libdap::Str, and libdap::UInt64.

Definition at line 1288 of file BaseType.cc.

## dataset()

string libdap::BaseType::dataset | ( |  | ) | const

virtual inherited

Returns the name of the dataset used to create this instance.

A dataset from which the data is to be read. The meaning of this string will vary among different types of data sources. It may be the name of a data file or an identifier used to read data from a relational database.

Definition at line 355 of file BaseType.cc.

## deserialize() [1/2]

void libdap::Vector::deserialize | ( | D4StreamUnMarshaller & | um,
|  | DMR & | dmr
| ) |  |

override virtual

The DAP4 deserialization method.

Parameters

  um |
  dmr |

Exceptions

  Error | or InternalErr

Reimplemented from libdap::BaseType.

Definition at line 1134 of file Vector.cc.

## deserialize() [2/2]

bool libdap::Vector::deserialize | ( | UnMarshaller & | um,
|  | DDS * | dds,
|  | bool | reuse = `false`
| ) |  |

override virtual

Receive data from the net.

Receives data from the network connection identified by the `source` parameter. The data is put into the class data buffer according to the input `dds`.

This function is only used on the client side of the DODS client/server connection.

Parameters

  um | An UnMarshaller that knows how to deserialize data types
  dds | The Data Descriptor Structure object corresponding to this dataset. See The DODS User Manual for information about this structure. This would have been received from the server in an earlier transmission.
  reuse | A boolean value, indicating whether the class internal data storage can be reused or not. If this argument is TRUE, the class buffer is assumed to be large enough to hold the incoming data, and it is not reallocated. If FALSE, new storage is allocated. If the internal buffer has not been allocated at all, this argument has no effect.

Returns
  Always returns TRUE.

Exceptions

  Error | when a problem reading from the UnMarshaller is found.

See also
  DDS

Reimplemented from libdap::BaseType.

Definition at line 855 of file Vector.cc.

## dump()

void libdap::Vector::dump | ( | ostream & | strm | ) | const

override virtual

dumps information about this object

Displays the pointer value of this instance and information about this instance.

Parameters

  strm | C++ i/o stream to dump the information to

Returns
  void

Reimplemented from libdap::BaseType.

Definition at line 2665 of file Vector.cc.

## element_count()

int libdap::Vector::element_count | ( | bool | leaves | ) |

override virtual

Count the members of constructor types.

Return a count of the total number of variables in this variable. This is used to count the number of variables held by a constructor variable - for simple type and vector variables it always returns 1.

For compound data types, there are two ways to count members. You can count the members, or you can count the simple members and add that to the count of the compound members. For example, if a Structure contains an Int32 and another Structure that itself contains two Int32 members, the element count of the top-level structure could be two (one Int32 and one Structure) or three (one Int32 by itself and two Int32's in the subsidiary Structure). Use the leaves parameter to control which kind of counting you desire.

Returns
  Returns 1 for simple types. For compound members, the count depends on the leaves argument.

Parameters

  leaves | This parameter is only relevant if the object contains other compound data types. If FALSE, the function counts only the data variables mentioned in the object's declaration. If TRUE, it counts the simple members, and adds that to the sum of the counts for the compound members. This parameter has no effect for simple type variables.

Reimplemented from libdap::BaseType.

Definition at line 342 of file Vector.cc.

## FQN()

string libdap::BaseType::FQN | ( |  | ) | const

virtual inherited

Return the FQN for this variable. This will include the D4 Group component of the name.

Returns
  The FQN in a string

Reimplemented in libdap::Constructor, and libdap::D4Group.

Definition at line 329 of file BaseType.cc.

## get_ancestor()

BaseType * libdap::BaseType::get_ancestor | ( |  | ) |

virtual inherited

Definition at line 754 of file BaseType.cc.

## get_attr_table()

AttrTable & libdap::BaseType::get_attr_table | ( |  | ) |

virtual inherited

Get this variable's AttrTable. It's generally a bad idea to return a reference to a contained object, but in this case it seems that building an interface inside BaseType is overkill.

Use the AttrTable methods to manipulate the table.

Definition at line 579 of file BaseType.cc.

## get_buf()

char * libdap::Vector::get_buf | ( |  | ) |

inline

Provide access to internal data. Callers cannot delete this but can pass them to other methods.

Note
  Added so that the NCML handler can code some optimizations in its specialized versions of Array. jhrg 8/14/15

Returns
  A pointer to the data buffer for Vectors/Arrays of the cardinal types.

Definition at line 146 of file Vector.h.

## get_compound_buf()

vector< BaseType * > & libdap::Vector::get_compound_buf | ( |  | ) |

inline

Provide access to internal data by reference. Callers cannot delete this but can pass them to other methods.

Returns
  A reference to a vector of BaseType pointers. Treat with care; never delete these!

Definition at line 167 of file Vector.h.

## get_parent()

BaseType * libdap::BaseType::get_parent | ( |  | ) | const

virtual inherited

Return a pointer to the Constructor or Vector which holds (contains) this variable. If this variable is at the top level, this method returns null.

Returns
  A BaseType pointer to the variable's parent.

Definition at line 748 of file BaseType.cc.

## get_str()

vector< string > & libdap::Vector::get_str | ( |  | ) |

inline

Provide access to internal string data by reference. Callers cannot delete this but can pass them to other methods.

Returns
  A reference to a vector of strings

Definition at line 156 of file Vector.h.

## get_value_capacity()

unsigned int libdap::Vector::get_value_capacity | ( |  | ) | const

virtual

Return the capacity of the Vector in terms of number of elements of its data type that it can currently hold (i.e. not bytes). For example, this could be the size of the _buf array in bytes / sizeof(T) for the cardinal types T, or the capacity of the d_str vector if T is string or url type.

Definition at line 1700 of file Vector.cc.

## get_value_capacity_ll()

uint64_t libdap::Vector::get_value_capacity_ll | ( |  | ) | const

virtual

Definition at line 1705 of file Vector.cc.

## intern_data() [1/2]

void libdap::Vector::intern_data | ( |  | ) |

override virtual

Read data into this variable.

Parameters

  eval | Evaluator for a constraint expression
  dmr | DMR for the whole dataset

Reimplemented from libdap::BaseType.

Definition at line 1001 of file Vector.cc.

## intern_data() [2/2]

void libdap::Vector::intern_data | ( | ConstraintEvaluator & | eval,
|  | DDS & | dds
| ) |  |

override virtual

read data into a variable for later use

Most uses of a variable are to either serialize its data to a stream of some sort or to read values from some stream and intern those in the variable for later use. These operations are perform by serialize() and deserialize() which follow. This function performs essentially both of these operations without actually using a stream device. The data are read using the read() method(s) and loaded into the variables directly.

This method is intended to be used by objects which transform DAP objects like the DataDDS into an ASCII CSV representation.

Note
  A DAP2-only method

Parameters

  eval | A reference to a constraint evaluator
  dds | The complete DDS to which this variable belongs

Reimplemented from libdap::BaseType.

Definition at line 686 of file Vector.cc.

## is_constructor_type()

bool libdap::BaseType::is_constructor_type | ( |  | ) | const

virtual inherited

Returns true if the instance is a constructor (i.e., Structure, Sequence or Grid) type variable.

Returns
  True if the instance is a Structure, Sequence or Grid, False otherwise.

Definition at line 409 of file BaseType.cc.

## is_dap4()

virtual bool libdap::BaseType::is_dap4 | ( |  | ) | const

inline virtual inherited

Definition at line 183 of file BaseType.h.

## is_dap4_projected()

bool libdap::Vector::is_dap4_projected | ( | std::vector< std::string > & | inventory | ) |

override virtual

When send_p() is true and the attributes and/or the prototype variable is/has dap4 data type(s) then a description of the instance is added to the inventory and true is returned.

Parameters

  inventory | is a value-result parameter

Returns
  True when send_p() is true and prototype variable is/contains dap4 typed variables and/or attributes, false otherwise

Reimplemented from libdap::BaseType.

Definition at line 2631 of file Vector.cc.

## is_in_selection()

bool libdap::BaseType::is_in_selection | ( |  | ) |

virtual inherited

Is this variable part of the current selection?

Does this variable appear in either the selection part or as a function argument in the current constrain expression. If this property is set (true) then implementations of the read() method should read this variable.

Note
  This method does not check, nor does it know about the semantics of, string arguments passed to functions. Those functions might include variable names in strings; they are responsible for reading those variables. See the grid (func_grid_select()) for an example.

See also
  BaseType::read()

Definition at line 700 of file BaseType.cc.

## is_simple_type()

bool libdap::BaseType::is_simple_type | ( |  | ) | const

virtual inherited

Returns true if the instance is a numeric, string or URL type variable.

Returns
  True if the instance is a scalar numeric, String or URL variable, False otherwise. Arrays (even of simple types) return False.

See also
  is_vector_type()

Definition at line 390 of file BaseType.cc.

## is_vector_type()

bool libdap::BaseType::is_vector_type | ( |  | ) | const

virtual inherited

Returns true if the instance is a vector (i.e., array) type variable.

Returns
  True if the instance is an Array, False otherwise.

Definition at line 399 of file BaseType.cc.

## length()

int libdap::Vector::length | ( |  | ) | const

inline override virtual

Returns the number of elements in the vector. Note that some child classes of Vector use the length of -1 as a flag value.

Returns
  The number of elements in the vector

Deprecated:
  Use length_ll() instead

Reimplemented from libdap::BaseType.

Definition at line 218 of file Vector.h.

## length_ll()

int64_t libdap::Vector::length_ll | ( |  | ) | const

inline override virtual

Get the number of elements in this Vector/Array This version of the function deprecates length() which is limited to 32-bit sizes. The field uses -1 as a sentinel value indicating that the Vector/Array holds no values yet (as opposed to zero values).

Returns
  The number of elements in this Vector/Array

Reimplemented from libdap::BaseType.

Definition at line 226 of file Vector.h.

## m_duplicate()

void libdap::BaseType::m_duplicate | ( | const BaseType & | bt | ) |

protected inherited

Perform a deep copy.

Perform a deep copy. Copies the values of bt into `*this`. Pointers are dereferenced and their values are copied into a newly allocated instance.

Parameters

  bt | The source object.

Definition at line 86 of file BaseType.cc.

## name()

string libdap::BaseType::name | ( |  | ) | const

virtual inherited

Returns the name of the class instance.

Definition at line 317 of file BaseType.cc.

## operator=()

Vector & libdap::Vector::operator= | ( | const Vector & | rhs | ) |

Definition at line 323 of file Vector.cc.

## ops()

bool libdap::BaseType::ops | ( | BaseType * | b,
|  | int | op
| ) |  |

virtual inherited

Evaluate relational operators.

This method contains the relational operators used by the constraint expression evaluator in the DDS class. Each class that wants to be able to evaluate relational expressions must overload this function. The implementation in BaseType throws an InternalErr exception. The DAP library classes Byte, ..., Url provide specializations of this method. It is not meaningful for classes such as Array because relational expressions using Array are not supported.

The op argument refers to a table generated by bison from the constraint expression parser. Use statements like the following to correctly interpret its value:

    switch (op) {
        case EQUAL: return i1 == i2;
        case NOT_EQUAL: return i1 != i2;
        case GREATER: return i1 > i2;
        case GREATER_EQL: return i1 >= i2;
        case LESS: return i1 < i2;
        case LESS_EQL: return i1 <= i2;
        case REGEXP: throw Error("Regular expressions are not supported for integer values");
        default: throw Error("Unknown operator");
    }

This function is used by the constraint expression evaluator.

Parameters

  b | Compare the value of this instance with b.
  op | An integer index indicating which relational operator is implied. Choose one from the following: `EQUAL`, `NOT_EQUAL`, `GREATER`, `GREATER_EQL`, `LESS`, `LESS_EQL`, and `REGEXP`.

Returns
  The boolean value of the comparison.

See also
  BaseType::d4_ops(BaseType *, int)

Reimplemented in libdap::D4Opaque, libdap::Byte, libdap::D4Enum, libdap::Float32, libdap::Float64, libdap::Int16, libdap::Int32, libdap::Int64, libdap::Int8, libdap::Str, libdap::UInt16, libdap::UInt32, and libdap::UInt64.

Definition at line 1262 of file BaseType.cc.

## print_dap4()

void libdap::BaseType::print_dap4 | ( | XMLWriter & | xml,
|  | bool | constrained = `false`
| ) |  |

virtual inherited

Write the DAP4 XML representation for this variable. This method is used to build the DAP4 DMR response object.

Parameters

  xml | An XMLWriter that will do the serialization
  constrained | True if the response should show the variables subject to the current constraint expression.

Reimplemented in libdap::Array, libdap::Constructor, and libdap::D4Group.

Definition at line 1170 of file BaseType.cc.

## print_decl() [1/2]

void libdap::BaseType::print_decl | ( | FILE * | out,
|  | string | space = `" "`,
|  | bool | print_semi = `true`,
|  | bool | constraint_info = `false`,
|  | bool | constrained = `false`
| ) |  |

virtual inherited

Print an ASCII representation of the variable structure.

Write the variable's declaration in a C-style syntax. This function is used to create textual representation of the Data Descriptor Structure (DDS). See The DODS User Manual for information about this structure.

A simple array declaration might look like this:

    Float64 lat[lat = 180];

While a more complex declaration (for a Grid, in this case), would look like this:

    Grid {
    ARRAY:
    Int32 sst[time = 404][lat = 180][lon = 360];
    MAPS:
    Float64 time[time = 404];
    Float64 lat[lat = 180];
    Float64 lon[lon = 360];
    } sst;

Parameters

  out | The output stream on which to print the declaration.
  space | Each line of the declaration will begin with the characters in this string. Usually used for leading spaces.
  print_semi | A boolean value indicating whether to print a semicolon at the end of the declaration.
  constraint_info | A boolean value indicating whether constraint information is to be printed with the declaration. If the value of this parameter is TRUE, `print_decl()` prints the value of the variable's `send_p()` flag after the declaration.
  constrained | If this boolean value is TRUE, the variable's declaration is only printed if is the `send_p()` flag is TRUE. If a constraint expression is in place, and this variable is not requested, the `send_p()` flag is FALSE.

See also
  DDS
  DDS::CE

Reimplemented in libdap::Grid, libdap::Array, libdap::Constructor, and libdap::D4Group.

Definition at line 1009 of file BaseType.cc.

## print_decl() [2/2]

void libdap::BaseType::print_decl | ( | ostream & | out,
|  | string | space = `" "`,
|  | bool | print_semi = `true`,
|  | bool | constraint_info = `false`,
|  | bool | constrained = `false`
| ) |  |

virtual inherited

Print an ASCII representation of the variable structure.

Write the variable's declaration in a C-style syntax. This function is used to create textual representation of the Data Descriptor Structure (DDS). See The DODS User Manual for information about this structure.

A simple array declaration might look like this:

    Float64 lat[lat = 180];

While a more complex declaration (for a Grid, in this case), would look like this:

    Grid {
    ARRAY:
    Int32 sst[time = 404][lat = 180][lon = 360];
    MAPS:
    Float64 time[time = 404];
    Float64 lat[lat = 180];
    Float64 lon[lon = 360];
    } sst;

Parameters

  out | The output stream on which to print the declaration.
  space | Each line of the declaration will begin with the characters in this string. Usually used for leading spaces.
  print_semi | A boolean value indicating whether to print a semicolon at the end of the declaration.
  constraint_info | A boolean value indicating whether constraint information is to be printed with the declaration. If the value of this parameter is TRUE, `print_decl()` prints the value of the variable's `send_p()` flag after the declaration.
  constrained | If this boolean value is TRUE, the variable's declaration is only printed if is the `send_p()` flag is TRUE. If a constraint expression is in place, and this variable is not requested, the `send_p()` flag is FALSE.

See also
  DDS
  DDS::CE

Reimplemented in libdap::Grid, libdap::Array, libdap::Constructor, and libdap::D4Group.

Definition at line 1060 of file BaseType.cc.

## print_val() [1/2]

void libdap::BaseType::print_val | ( | FILE * | out,
|  | string | space = `""`,
|  | bool | print_decl_p = `true`
| ) |  |

virtual inherited

Prints the value of the variable.

Prints the value of the variable, with its declaration. This function is primarily intended for debugging DODS applications. However, it can be overloaded and used to do some useful things. Take a look at the asciival and writeval clients, both of which overload this to output the values of variables in different ways.

Parameters

  out | The output stream on which to print the value.
  space | This value is passed to the print_decl() function, and controls the leading spaces of the output.
  print_decl_p | A boolean value controlling whether the variable declaration is printed as well as the value.

Prints the value of the variable, with its declaration. This function is primarily intended for debugging DODS applications. However, it can be overloaded and used to do some useful things. Take a look at the asciival and writeval clients, both of which overload this to output the values of variables in different ways.

Parameters

  out | The output stream on which to print the value.
  space | This value is passed to the print_decl() function, and controls the leading spaces of the output.
  print_decl_p | A boolean value controlling whether the variable declaration is printed as well as the value.

Reimplemented in libdap::D4Opaque, libdap::Grid, libdap::Sequence, libdap::Array, libdap::Byte, libdap::Constructor, libdap::D4Group, libdap::Float32, libdap::Float64, libdap::Int16, libdap::Int32, libdap::Str, libdap::UInt16, and libdap::UInt32.

Definition at line 1096 of file BaseType.cc.

## print_val() [2/2]

virtual void libdap::BaseType::print_val | ( | ostream & | out,
|  | string | space = `""`,
|  | bool | print_decl_p = `true`
| ) |  |

pure virtual inherited

Prints the value of the variable.

Prints the value of the variable, with its declaration. This function is primarily intended for debugging DODS applications. However, it can be overloaded and used to do some useful things. Take a look at the asciival and writeval clients, both of which overload this to output the values of variables in different ways.

Parameters

  out | The output ostream on which to print the value.
  space | This value is passed to the print_decl() function, and controls the leading spaces of the output.
  print_decl_p | A boolean value controlling whether the variable declaration is printed as well as the value.

Implemented in libdap::Grid, libdap::Sequence, libdap::Array, libdap::Byte, libdap::Constructor, libdap::D4Enum, libdap::D4Group, libdap::D4Sequence, libdap::Float32, libdap::Float64, libdap::Int16, libdap::Int32, libdap::Int64, libdap::Int8, libdap::Str, libdap::UInt16, libdap::UInt32, libdap::UInt64, and libdap::D4Opaque.

## print_xml() [1/2]

void libdap::BaseType::print_xml | ( | FILE * | out,
|  | string | space = `" "`,
|  | bool | constrained = `false`
| ) |  |

virtual inherited

Write the XML representation of this variable. This method is used to build the DDX XML response.

Parameters

  out | Destination.
  space | Use this to indent child declarations. Default is "".
  constrained | If true, only print this if it's part part of the current projection. Default is False.

Deprecated:

Reimplemented in libdap::Grid, libdap::Array, and libdap::Constructor.

Definition at line 1111 of file BaseType.cc.

## print_xml() [2/2]

void libdap::BaseType::print_xml | ( | ostream & | out,
|  | string | space = `" "`,
|  | bool | constrained = `false`
| ) |  |

virtual inherited

Write the XML representation of this variable. This method is used to build the DDX XML response.

Parameters

  out | Destination output stream
  space | Use this to indent child declarations. Default is "".
  constrained | If true, only print this if it's part part of the current projection. Default is False.

Deprecated:

Reimplemented in libdap::Grid, libdap::Array, and libdap::Constructor.

Definition at line 1126 of file BaseType.cc.

## print_xml_writer()

void libdap::BaseType::print_xml_writer | ( | XMLWriter & | xml,
|  | bool | constrained = `false`
| ) |  |

virtual inherited

Write the XML representation of this variable. This method is used to build the DDX XML response.

Parameters

  out | Destination output stream
  space | Use this to indent child declarations. Default is "".
  constrained | If true, only print this if it's part part of the current projection. Default is False.

Reimplemented in libdap::D4Enum, libdap::Grid, libdap::Array, and libdap::Constructor.

Definition at line 1140 of file BaseType.cc.

## prototype()

virtual BaseType * libdap::Vector::prototype | ( |  | ) | const

inline virtual

Definition at line 171 of file Vector.h.

## ptr_duplicate()

virtual BaseType * libdap::BaseType::ptr_duplicate | ( |  | ) |

pure virtual inherited

Clone this instance. Allocate a new instance and copy `*this` into it. This method must perform a deep copy.

    @note This method should \e not copy data values, but must copy all
    other fields in the object.

Returns
  A newly allocated copy of `this`.

Implemented in libdap::Grid, libdap::Sequence, libdap::Structure, libdap::Url, libdap::Array, libdap::Byte, libdap::D4Enum, libdap::D4Group, libdap::D4Opaque, libdap::D4Sequence, libdap::Float32, libdap::Float64, libdap::Int16, libdap::Int32, libdap::Int64, libdap::Int8, libdap::Str, libdap::UInt16, libdap::UInt32, and libdap::UInt64.

## read()

bool libdap::BaseType::read | ( |  | ) |

virtual inherited

Read data into a local buffer.

This method should be implemented for each of the data type classes (Byte, ..., Grid) when using the DAP class library to build a server. This method is only for DAP servers. The library provides a default definition here which throws an InternalErr exception unless the read_p property has been set. In that case it returns false, indicating that all the data have been read. The latter case can happen when building a constant value that needs to be passed to a function. The variable/constant is loaded with a value when it is created.

When implementing a new DAP server, the Byte, ..., Grid data type classes are usually specialized. In each of those specializations read() should be defined to read values from the data source and store them in the object's local buffer. The read() method is called by other methods in this library. When writing read(), follow these rules:

- read() should throw Error if it encounters an error. The message should be verbose enough to be understood by someone running a client on a different machine.
- The value(s) should be read if and only if either send_p() or is_in_selection() return true. If neither of these return true, the value(s) should not be read. This is important when writing read() for a Constructor type such as Grid where a client may ask for only the map vectors (and thus reading the much larger Array part is not needed).
- For each specialization of read(), the method should first test the value of the `read_p` property (using the read_p() method) and read values only if the value of read_p() is false. Once the read() method reads data and stores it in the instance, it must set the value of the `read_p` property to true using set_read_p(). If your read() methods fail to do this data may not serialize correctly.
- The Array::read() and Grid::read() methods should take into account any restrictions on Array sizes.
- If you are writing Sequence::read(), be sure to check the documentation for Sequence::read_row() and Sequence::serialize() so you understand how Sequence::read() is being called.

- For Sequence::read(), your specialization must correctly manage the `unsent_data` property and row count in addition to the `read_p` property (handle the `read_p` property as describe above). For a Sequence to serialize correctly, once all data from the Sequence has been read, `unsent_data` property must be set to false (use Sequence::set_unsent_data()). Also, at that time the row number counter must be reset (use Sequence::reset_row_counter()). Typically the correct time to set `unsent_data` to false and reset the row counter is the time when Sequence::read() return false indicating that all the data for the Sequence have been read. Failure to handle these tasks will break serialization of nested Sequences. Note that when Sequence::read() returns with a result of true (indicating there is more data to send, the value of the `unsent_data` property should be true.

  Also, if you server must handle nested sequences, be sure to read about subclassing set_read_p().

Todo:
  Modify the D4 serialize code so that it supports the true/false behavior of read() for arrays.

Todo:
  Modify all of the stock handlers so they conform to this!

Returns
  False means more data remains to be read, True indicates that no more data need to be read. For Sequence and D4Sequence, this method will generally read one instance of the Sequence; for other types it will generally read the entire variable modulo any limitations due to a constraint. However, the library should be written so that read can return less than all of the data for a variable - serialize() would then call the function until it returns True.

See also
  BaseType

Reimplemented in libdap::Constructor.

Definition at line 905 of file BaseType.cc.

## read_p()

bool libdap::BaseType::read_p | ( |  | ) |

virtual inherited

Has this variable been read?

Returns true if the value(s) for this variable have been read from the data source, otherwise returns false. This method is used to determine when values need to be read using the read() method. When read_p() returns true, this library assumes that buf2val() (and other methods such as get_vec()) can be used to access the value(s) of a variable.

Returns
  True if the variable's value(s) have been read, false otherwise.

Definition at line 477 of file BaseType.cc.

## reserve_value_capacity() [1/2]

void libdap::Vector::reserve_value_capacity | ( |  | ) |

virtual

Make sure there's storage allocated for the current length() of the Vector. Same as reserveValueCapacity(length())

Definition at line 1780 of file Vector.cc.

## reserve_value_capacity() [2/2]

void libdap::Vector::reserve_value_capacity | ( | unsigned int | numElements | ) |

virtual

Allocate enough memory for the Vector to contain numElements data elements of the Vector's type. Must be used before set_value_slice_from_row_major_vector to ensure memory exists.

Parameters

  numElements | the number of elements of the Vector's type to preallocate storage for.

Exceptions

  if | the memory cannot be allocated

Definition at line 1718 of file Vector.cc.

## reserve_value_capacity_ll() [1/2]

void libdap::Vector::reserve_value_capacity_ll | ( |  | ) |

virtual

Make sure there's storage allocated for the current length() of the Vector. Same as reserveValueCapacity(length())

Definition at line 1856 of file Vector.cc.

## reserve_value_capacity_ll() [2/2]

void libdap::Vector::reserve_value_capacity_ll | ( | uint64_t | numElements | ) |

virtual

Allocate enough memory for the Vector to contain numElements data elements of the Vector's type. Must be used before set_value_slice_from_row_major_vector to ensure memory exists.

Parameters

  numElements | the number of elements of the Vector's type to preallocate storage for.

Exceptions

  if | the memory cannot be allocated

Definition at line 1794 of file Vector.cc.

## reserve_value_capacity_ll_byte()

void libdap::Vector::reserve_value_capacity_ll_byte | ( | uint64_t | numBytes | ) |

virtual

A light-weight method to allocate the storage size in bytes of the Vector. This method is necessary for operations like direct IO in the BES.

Definition at line 1867 of file Vector.cc.

## send_p()

bool libdap::BaseType::send_p | ( |  | ) |

virtual inherited

Should this variable be sent?

Returns the state of the `send_p` property. If true, this variable should be sent to the client, if false, it should not. If no constraint expression (CE) has been evaluated, this property is true for all variables in a data source (i.e., for all the variables listed in a DDS). If a CE has been evaluated, this property is true only for those variables listed in the projection part of the CE.

Returns
  True if the variable should be sent to the client, false otherwise.

Definition at line 551 of file BaseType.cc.

## serialize() [1/2]

bool libdap::Vector::serialize | ( | ConstraintEvaluator & | eval,
|  | DDS & | dds,
|  | Marshaller & | m,
|  | bool | ce_eval = `true`
| ) |  |

override virtual

Serialize a Vector.

This uses the Marshaller class to encode each element of a cardinal array. For Arrays of Str and Url types, send the element count over as a prefix to the data so that deserialize will know how many elements to read.

NB: Arrays of cardinal types must already be in BUF (in the local machine's representation) before this call is made.

Reimplemented from libdap::BaseType.

Definition at line 752 of file Vector.cc.

## serialize() [2/2]

void libdap::Vector::serialize | ( | D4StreamMarshaller & | m,
|  | DMR & | dmr,
|  | bool | filter = `false`
| ) |  |

override virtual

The DAP4 serialization method. Serialize a variable's values for DAP4. This does not write the DMR persistent representation but does write that part of the binary data blob that holds a variable's data. Once a variable's data are serialized, that memory is reclaimed (by calling BaseType::clear_local_data())

Parameters

  m |
  dmr |
  eval |
  filter | True if there is one variable that should be 'filtered'

Exceptions

  Error | or InternalErr

Reimplemented from libdap::BaseType.

Definition at line 1049 of file Vector.cc.

## set_attr_table()

void libdap::BaseType::set_attr_table | ( | const AttrTable & | at | ) |

virtual inherited

Set this variable's attribute table.

Parameters

  at | Source of the attributes.

Definition at line 587 of file BaseType.cc.

## set_attributes()

void libdap::BaseType::set_attributes | ( | D4Attributes * | attrs | ) |

virtual inherited

Definition at line 603 of file BaseType.cc.

## set_attributes_nocopy()

void libdap::BaseType::set_attributes_nocopy | ( | D4Attributes * | attrs | ) |

virtual inherited

Definition at line 609 of file BaseType.cc.

## set_in_selection()

void libdap::BaseType::set_in_selection | ( | bool | state | ) |

virtual inherited

Set the in_selection property to state. This property indicates that the variable is used as a parameter to a constraint expression function or that it appears as an argument in a selection sub-expression. If set (true), implementations of the BaseType::read() method should read this variable.

Parameters

  state | Set the in_selection property to this state.

See also
  BaseType::read()
  BaseType::is_in_selection() for more information.

Reimplemented in libdap::Constructor.

Definition at line 715 of file BaseType.cc.

## set_is_dap4()

virtual void libdap::BaseType::set_is_dap4 | ( | const bool | v | ) |

inline virtual inherited

Definition at line 184 of file BaseType.h.

## set_length()

void libdap::Vector::set_length | ( | int64_t | l | ) |

override virtual

Sets the length of the vector. This function does not allocate any new space.

This updated version can accept sizes that are too big for a DAP2 Array, but if that happens, a flag is set.

Parameters

  l | The number of elements

Deprecated:
  Use set_length_ll() instead

Reimplemented from libdap::BaseType.

Definition at line 434 of file Vector.cc.

## set_length_ll()

void libdap::Vector::set_length_ll | ( | int64_t | l | ) |

override virtual

Set the number of elements in this Vector/Array This version of the function deprecates set_length() which is limited to 32-bit sizes. The field uses -1 as a sentinel value indicating that the Vector/Array holds no values.

Parameters

  l | The number of elements in the Vector/Array

Reimplemented from libdap::BaseType.

Definition at line 446 of file Vector.cc.

## set_name()

void libdap::Vector::set_name | ( | const std::string & | n | ) |

override virtual

Sets the name of the class instance.

Reimplemented from libdap::BaseType.

Definition at line 332 of file Vector.cc.

## set_parent()

void libdap::BaseType::set_parent | ( | BaseType * | parent | ) |

virtual inherited

Set the `parent` property for this variable.

Note
  Added ability to set parent to null. 10/19/12 jhrg

Parameters

  parent | Pointer to the Constructor of Vector parent variable or null if the variable has no parent (if it is at the top-level of a DAP2/3 DDS).

Exceptions

  InternalErr | thrown if called with anything other than a Constructor, Vector or Null.

Definition at line 730 of file BaseType.cc.

## set_prototype()

virtual BaseType * libdap::Vector::set_prototype | ( | BaseType * | btp | ) |

inline virtual

Change the Vector/Array element type.

Parameters

  btp |

Returns
  The previous template, calling code is responsible for the returned BaseType lifecycle.

Definition at line 178 of file Vector.h.

## set_read_p()

void libdap::Vector::set_read_p | ( | bool | state | ) |

override virtual

Indicates that the data is ready to send.

This function sets the `read_p` flag for both the Vector itself and its element template. This does not matter much when the Vector contains simple data types, but does become significant when the Vector contains compound types.

Reimplemented from libdap::BaseType.

Definition at line 400 of file Vector.cc.

## set_send_p()

void libdap::Vector::set_send_p | ( | bool | state | ) |

override virtual

Indicates that the data is ready to send.

This function sets the `send_p` flag for both the Vector itself and its element template. This does not matter much when the Vector contains simple data types, but does become significant when the Vector contains compound types.

Reimplemented from libdap::BaseType.

Definition at line 363 of file Vector.cc.

## set_synthesized_p()

void libdap::BaseType::set_synthesized_p | ( | bool | state | ) |

virtual inherited

Set the synthesized flag. Before setting this flag be sure to set the `read_p()` state. Once this flag is set you cannot alter the state of the `read_p` flag!

See also
  synthesized_p()

Definition at line 460 of file BaseType.cc.

## set_type()

void libdap::BaseType::set_type | ( | const Type & | t | ) |

virtual inherited

Sets the type of the class instance.

Definition at line 369 of file BaseType.cc.

## set_value() [1/22]

bool libdap::Vector::set_value | ( | dods_byte * | val,
|  | int | sz
| ) |  |

virtual

Definition at line 2072 of file Vector.cc.

## set_value() [2/22]

bool libdap::Vector::set_value | ( | dods_float32 * | val,
|  | int | sz
| ) |  |

virtual

Definition at line 2105 of file Vector.cc.

## set_value() [3/22]

bool libdap::Vector::set_value | ( | dods_float64 * | val,
|  | int | sz
| ) |  |

virtual

Definition at line 2109 of file Vector.cc.

## set_value() [4/22]

bool libdap::Vector::set_value | ( | dods_int16 * | val,
|  | int | sz
| ) |  |

virtual

Definition at line 2081 of file Vector.cc.

## set_value() [5/22]

bool libdap::Vector::set_value | ( | dods_int32 * | val,
|  | int | sz
| ) |  |

virtual

Definition at line 2089 of file Vector.cc.

## set_value() [6/22]

bool libdap::Vector::set_value | ( | dods_int64 * | val,
|  | int | sz
| ) |  |

virtual

Definition at line 2097 of file Vector.cc.

## set_value() [7/22]

bool libdap::Vector::set_value | ( | dods_int8 * | val,
|  | int | sz
| ) |  |

virtual

Definition at line 2077 of file Vector.cc.

## set_value() [8/22]

bool libdap::Vector::set_value | ( | dods_uint16 * | val,
|  | int | sz
| ) |  |

virtual

Definition at line 2085 of file Vector.cc.

## set_value() [9/22]

bool libdap::Vector::set_value | ( | dods_uint32 * | val,
|  | int | sz
| ) |  |

virtual

Definition at line 2093 of file Vector.cc.

## set_value() [10/22]

bool libdap::Vector::set_value | ( | dods_uint64 * | val,
|  | int | sz
| ) |  |

virtual

Definition at line 2101 of file Vector.cc.

## set_value() [11/22]

bool libdap::Vector::set_value | ( | string * | val,
|  | int | sz
| ) |  |

virtual

set the value of a string or url array

Parameters

  val | An array of string objects
  sz | The number of elements in the string array

Returns
  false if the type of the array is neither Str nor Url or val is null, otherwise returns true.

Definition at line 2164 of file Vector.cc.

## set_value() [12/22]

bool libdap::Vector::set_value | ( | vector< dods_byte > & | val,
|  | int | sz
| ) |  |

virtual

Definition at line 2217 of file Vector.cc.

## set_value() [13/22]

bool libdap::Vector::set_value | ( | vector< dods_float32 > & | val,
|  | int | sz
| ) |  |

virtual

Definition at line 2249 of file Vector.cc.

## set_value() [14/22]

bool libdap::Vector::set_value | ( | vector< dods_float64 > & | val,
|  | int | sz
| ) |  |

virtual

Definition at line 2253 of file Vector.cc.

## set_value() [15/22]

bool libdap::Vector::set_value | ( | vector< dods_int16 > & | val,
|  | int | sz
| ) |  |

virtual

Definition at line 2225 of file Vector.cc.

## set_value() [16/22]

bool libdap::Vector::set_value | ( | vector< dods_int32 > & | val,
|  | int | sz
| ) |  |

virtual

Definition at line 2233 of file Vector.cc.

## set_value() [17/22]

bool libdap::Vector::set_value | ( | vector< dods_int64 > & | val,
|  | int | sz
| ) |  |

virtual

Definition at line 2241 of file Vector.cc.

## set_value() [18/22]

bool libdap::Vector::set_value | ( | vector< dods_int8 > & | val,
|  | int | sz
| ) |  |

virtual

Definition at line 2221 of file Vector.cc.

## set_value() [19/22]

bool libdap::Vector::set_value | ( | vector< dods_uint16 > & | val,
|  | int | sz
| ) |  |

virtual

Definition at line 2229 of file Vector.cc.

## set_value() [20/22]

bool libdap::Vector::set_value | ( | vector< dods_uint32 > & | val,
|  | int | sz
| ) |  |

virtual

Definition at line 2237 of file Vector.cc.

## set_value() [21/22]

bool libdap::Vector::set_value | ( | vector< dods_uint64 > & | val,
|  | int | sz
| ) |  |

virtual

Definition at line 2245 of file Vector.cc.

## set_value() [22/22]

bool libdap::Vector::set_value | ( | vector< string > & | val,
|  | int | sz
| ) |  |

virtual

set the value of a string or url array

Definition at line 2301 of file Vector.cc.

## set_value_capacity()

void libdap::Vector::set_value_capacity | ( | uint64_t | l | ) |

Definition at line 457 of file Vector.cc.

## set_value_ll() [1/22]

bool libdap::Vector::set_value_ll | ( | dods_byte * | val,
|  | int64_t | sz
| ) |  |

virtual

Definition at line 2114 of file Vector.cc.

## set_value_ll() [2/22]

bool libdap::Vector::set_value_ll | ( | dods_float32 * | val,
|  | int64_t | sz
| ) |  |

virtual

Definition at line 2147 of file Vector.cc.

## set_value_ll() [3/22]

bool libdap::Vector::set_value_ll | ( | dods_float64 * | val,
|  | int64_t | sz
| ) |  |

virtual

Definition at line 2151 of file Vector.cc.

## set_value_ll() [4/22]

bool libdap::Vector::set_value_ll | ( | dods_int16 * | val,
|  | int64_t | sz
| ) |  |

virtual

Definition at line 2123 of file Vector.cc.

## set_value_ll() [5/22]

bool libdap::Vector::set_value_ll | ( | dods_int32 * | val,
|  | int64_t | sz
| ) |  |

virtual

Definition at line 2131 of file Vector.cc.

## set_value_ll() [6/22]

bool libdap::Vector::set_value_ll | ( | dods_int64 * | val,
|  | int64_t | sz
| ) |  |

virtual

Definition at line 2139 of file Vector.cc.

## set_value_ll() [7/22]

bool libdap::Vector::set_value_ll | ( | dods_int8 * | val,
|  | int64_t | sz
| ) |  |

virtual

Definition at line 2119 of file Vector.cc.

## set_value_ll() [8/22]

bool libdap::Vector::set_value_ll | ( | dods_uint16 * | val,
|  | int64_t | sz
| ) |  |

virtual

Definition at line 2127 of file Vector.cc.

## set_value_ll() [9/22]

bool libdap::Vector::set_value_ll | ( | dods_uint32 * | val,
|  | int64_t | sz
| ) |  |

virtual

Definition at line 2135 of file Vector.cc.

## set_value_ll() [10/22]

bool libdap::Vector::set_value_ll | ( | dods_uint64 * | val,
|  | int64_t | sz
| ) |  |

virtual

Definition at line 2143 of file Vector.cc.

## set_value_ll() [11/22]

bool libdap::Vector::set_value_ll | ( | string * | val,
|  | int64_t | sz
| ) |  |

virtual

Definition at line 2184 of file Vector.cc.

## set_value_ll() [12/22]

bool libdap::Vector::set_value_ll | ( | vector< dods_byte > & | val,
|  | int64_t | sz
| ) |  |

virtual

Definition at line 2258 of file Vector.cc.

## set_value_ll() [13/22]

bool libdap::Vector::set_value_ll | ( | vector< dods_float32 > & | val,
|  | int64_t | sz
| ) |  |

virtual

Definition at line 2290 of file Vector.cc.

## set_value_ll() [14/22]

bool libdap::Vector::set_value_ll | ( | vector< dods_float64 > & | val,
|  | int64_t | sz
| ) |  |

virtual

Definition at line 2294 of file Vector.cc.

## set_value_ll() [15/22]

bool libdap::Vector::set_value_ll | ( | vector< dods_int16 > & | val,
|  | int64_t | sz
| ) |  |

virtual

Definition at line 2266 of file Vector.cc.

## set_value_ll() [16/22]

bool libdap::Vector::set_value_ll | ( | vector< dods_int32 > & | val,
|  | int64_t | sz
| ) |  |

virtual

Definition at line 2274 of file Vector.cc.

## set_value_ll() [17/22]

bool libdap::Vector::set_value_ll | ( | vector< dods_int64 > & | val,
|  | int64_t | sz
| ) |  |

virtual

Definition at line 2282 of file Vector.cc.

## set_value_ll() [18/22]

bool libdap::Vector::set_value_ll | ( | vector< dods_int8 > & | val,
|  | int64_t | sz
| ) |  |

virtual

Definition at line 2262 of file Vector.cc.

## set_value_ll() [19/22]

bool libdap::Vector::set_value_ll | ( | vector< dods_uint16 > & | val,
|  | int64_t | sz
| ) |  |

virtual

Definition at line 2270 of file Vector.cc.

## set_value_ll() [20/22]

bool libdap::Vector::set_value_ll | ( | vector< dods_uint32 > & | val,
|  | int64_t | sz
| ) |  |

virtual

Definition at line 2278 of file Vector.cc.

## set_value_ll() [21/22]

bool libdap::Vector::set_value_ll | ( | vector< dods_uint64 > & | val,
|  | int64_t | sz
| ) |  |

virtual

Definition at line 2286 of file Vector.cc.

## set_value_ll() [22/22]

bool libdap::Vector::set_value_ll | ( | vector< string > & | val,
|  | int64_t | sz
| ) |  |

virtual

Definition at line 2318 of file Vector.cc.

## set_value_slice_from_row_major_vector()

uint64_t libdap::Vector::set_value_slice_from_row_major_vector | ( | const Vector & | rowMajorDataC,
|  | uint64_t | startElement
| ) |  |

virtual

Copy rowMajorData.length() elements currently in a rowMajorData buffer into this value buffer starting at element index startElement and continuing up to startElement+rowMajorData.length()-1

This is used for aggregating together smaller rowMajor vectors into a larger one.

Note: unlike the other set_value calls, this does NOT set read_p() since it is assumed to be used as a partial read and the caller is expected to set_read_p() when the data is complete.

ASSUMES: rowMajorData.read_p() so that the data is valid! ASSUMES: this Vector has enough value_capacity() to contain all the elements such that: startElement + rowMajorData.length() <= this->value_capacity(). ASSUMES: the data type of this->var() and rowMajorData.var() MUST be non-NULL and be the same!

Parameters

  rowMajorDataC | the vector from which to copy data, assumed already read in or set.
  startElement | the element index (NOT byte, but rather data type element) to place the first data value.

Returns
  the number of elements added, such that: startElement + the return value is the next "free" element.

Definition at line 1901 of file Vector.cc.

## set_vec()

void libdap::Vector::set_vec | ( | unsigned int | i,
|  | BaseType * | val
| ) |  |

Sets element i to value val.

Sets an element of the vector to a given value. If the type of the input and the type of the Vector do not match, an error condition is returned.

Use this function only with Vectors containing compound types. See `buf2val()` or the `set_value()` methods to access members of Vector containing simple types.

Note
  This method copies val; the caller is responsible for deleting instance passed as the actual parameter.

Returns
  void

Exceptions

  InternalErr | Thrown if i is out of range, val is null or there was a type mismatch between the BaseType referenced by val and the ith element of this Vector.

Parameters

  i | The index of the element to be changed.
  val | A pointer to the value to be inserted into the array.

See also
  Vector::buf2val

Definition at line 1585 of file Vector.cc.

## set_vec_ll()

void libdap::Vector::set_vec_ll | ( | uint64_t | i,
|  | BaseType * | val
| ) |  |

Definition at line 1590 of file Vector.cc.

## set_vec_nocopy()

void libdap::Vector::set_vec_nocopy | ( | unsigned int | i,
|  | BaseType * | val
| ) |  |

Sets element i to value val. Set the ith element to val. Extend the vector if needed.

Note
  It is best to call vec_resize() first and allocate enough elements before calling this method.
  This method does not copy val; this class will free the instance when the variable is deleted or when clear_local_data() is called.

See also
  Vector::set_vec()

Definition at line 1606 of file Vector.cc.

## set_vec_nocopy_ll()

void libdap::Vector::set_vec_nocopy_ll | ( | uint64_t | i,
|  | BaseType * | val
| ) |  |

Definition at line 1634 of file Vector.cc.

## synthesized_p()

bool libdap::BaseType::synthesized_p | ( |  | ) |

virtual inherited

Returns true if the variable is a synthesized variable. A synthesized variable is one that is added to the dataset by the server (usually with a ‘projection function’.

Definition at line 449 of file BaseType.cc.

## toString()

string libdap::BaseType::toString | ( |  | ) |

virtual inherited

Write out the object's internal fields in a string. To be used for debugging when regular inspection w/ddd or gdb isn't enough.

Returns
  A string which shows the object's internal stuff.

Reimplemented in libdap::Sequence.

Definition at line 180 of file BaseType.cc.

## transfer_attributes()

void libdap::BaseType::transfer_attributes | ( | AttrTable * | at_container | ) |

virtual inherited

Transfer attributes from a DAS object into this variable. Because of the rough history of the DAS object and the way that various server code built the DAS, this is necessarily a heuristic process. The intent is that this method will be overridden by handlers that need to look for certain patterns in the DAS (e.g., hdf4's odd variable_dim_n; where n = 0, 1, 2, ...) attribute containers.

There should be a one-to-one mapping between variables and attribute containers. However, in some cases one variable has attributes spread across several top level containers and in some cases one container is used by several variables

Note
  This method is technically unnecessary because a server (or client) can easily add attributes directly using the DDS::get_attr_table or BaseType::get_attr_table methods and then poke values in using any of the methods AttrTable provides. This method exists to ease the transition to DDS objects which contain attribute information for the existing servers (Since they all make DAS objects separately from the DDS). They could be modified to use the same AttrTable methods but operate on the AttrTable instances in a DDS/BaseType instead of those in a DAS.

Parameters

  at_container | Transfer attributes from this container.

Returns
  void

Reimplemented in libdap::Constructor, and libdap::Grid.

Definition at line 641 of file BaseType.cc.

## transform_to_dap2()

std::vector< BaseType * > * libdap::BaseType::transform_to_dap2 | ( | AttrTable * | parent_attr_table | ) |

virtual inherited

DAP4 to DAP2 transform.

For the current BaseType, return a DAP2 'copy' of the variable.

Note
  For most DAP4 types, in this implementation of DAP2 the corresponding DAP4 type is the same. These types have a different representations in DAP2 and DAP4: Sequences (which are D4Sequences in the DAP4 implementation),
  - Grids (which are semantically subsumed by coverages in DAP4)
  - Arrays (which use shared dimensions in DAP4)

Additionally DAP4 adds the following types:

- UInt8, Int8, and Char which map to Byte in DAP2.
- Int64, Unit64 which have no natural representation in DAP2.
- Opaque Possible Byte stuff[] plus metadata?
- Enum's can be represented as Int32.
- Groups, with the exception of the root group "disappear" into the names of their member variables. Specifically the Group name is add as a prefix followed by a "/" separator to the names of all of the Group's member groups variables.

Parameters

  The | AttrTable pointer parent_attr_table is used by Groups, which disappear from the DAP2 representation. Their children are returned in the the BAseType vector their attributes are added to parent_attr_table;

Returns
  A pointer to a vector of BaseType pointers (right?). In most cases this vector will contain a single pointer but DAP4 types 'disappear' such as Group will return all of their member variables in the vector. DAP4 types with no representation in DAP2 (ex: UInt64) the will return a NULL pointer and so this must be tested!

Reimplemented in libdap::Structure, libdap::Array, libdap::Byte, libdap::D4Enum, libdap::D4Group, libdap::D4Opaque, libdap::Int64, libdap::Int8, and libdap::UInt64.

Definition at line 255 of file BaseType.cc.

## transform_to_dap4()

void libdap::BaseType::transform_to_dap4 | ( | D4Group * | root,
|  | Constructor * | container
| ) |  |

virtual inherited

DAP2 to DAP4 transform.

For the current BaseType, return a DAP4 'copy' of the variable.

Note
  For most DAP2 types, in this implementation of DAP4 the corresponding DAP4 type is the same. The different types are Sequences (which are D4Sequences in the DAP4 implementation), Grids (which are coverages) and Arrays (which use shared dimensions).

Parameters

  root | The root group that should hold this new variable. Add Group-level stuff here (e.g., D4Dimensions).
  container | Add the new variable to this container.

Returns
  A pointer to the transformed variable

Reimplemented in libdap::Grid, libdap::Sequence, libdap::Structure, libdap::Array, and libdap::Constructor.

Definition at line 212 of file BaseType.cc.

## type()

Type libdap::BaseType::type | ( |  | ) | const

virtual inherited

Returns the type of the class instance.

Definition at line 362 of file BaseType.cc.

## type_name()

string libdap::BaseType::type_name | ( |  | ) | const

virtual inherited

Returns the type of the class instance as a string.

Definition at line 376 of file BaseType.cc.

## val2buf()

unsigned int libdap::Vector::val2buf | ( | void * | val,
|  | bool | reuse = `false`
| ) |  |

override virtual

Reads data into the Vector buffer.

Copies data into the class instance buffer. This function assumes that the input val points to memory which contains, in row major order, enough elements of the correct type to fill the array. For an array of a cardinal type the memory is simply copied in whole into the Vector buffer.

If the variable has already been constrained, this method will load only number of values/bytes specified by that constraint and will load them into the 'front' of the object's internal buffer. This is where serialize() expects to find the data.

For a Vector of Str (OPeNDAP Strings), this assumes val points to an array of C++ strings.

This method should not be used for Structure, Sequence or Grid.

Exceptions

  InternalErr | Thrown if called for Structure, Sequence or Grid.

Returns
  The number of bytes used by the array.

Parameters

  val | A pointer to the input data.
  reuse | A boolean value, indicating whether the class internal data storage can be reused or not. If this argument is TRUE, the class buffer is assumed to be large enough to hold the incoming data, and it is not reallocated. If FALSE, new storage is allocated. If the internal buffer has not been allocated at all, this argument has no effect.

Implements libdap::BaseType.

Definition at line 1329 of file Vector.cc.

## val2buf_ll()

uint64_t libdap::Vector::val2buf_ll | ( | void * | val,
|  | bool | reuse = `false`
| ) |  |

Definition at line 1335 of file Vector.cc.

## value() [1/23]

void * libdap::Vector::value | ( |  | ) |

virtual

Allocate memory and copy data into the new buffer. Return the new buffer's pointer. The caller must delete the storage.

Definition at line 2527 of file Vector.cc.

## value() [2/23]

void libdap::Vector::value | ( | dods_byte * | b | ) | const

virtual

Definition at line 2493 of file Vector.cc.

## value() [3/23]

void libdap::Vector::value | ( | dods_float32 * | b | ) | const

virtual

Definition at line 2501 of file Vector.cc.

## value() [4/23]

void libdap::Vector::value | ( | dods_float64 * | b | ) | const

virtual

Definition at line 2502 of file Vector.cc.

## value() [5/23]

void libdap::Vector::value | ( | dods_int16 * | b | ) | const

virtual

Definition at line 2495 of file Vector.cc.

## value() [6/23]

void libdap::Vector::value | ( | dods_int32 * | b | ) | const

virtual

Definition at line 2497 of file Vector.cc.

## value() [7/23]

void libdap::Vector::value | ( | dods_int64 * | b | ) | const

virtual

Definition at line 2499 of file Vector.cc.

## value() [8/23]

void libdap::Vector::value | ( | dods_int8 * | b | ) | const

virtual

Definition at line 2494 of file Vector.cc.

## value() [9/23]

void libdap::Vector::value | ( | dods_uint16 * | b | ) | const

virtual

Definition at line 2496 of file Vector.cc.

## value() [10/23]

void libdap::Vector::value | ( | dods_uint32 * | b | ) | const

virtual

Definition at line 2498 of file Vector.cc.

## value() [11/23]

void libdap::Vector::value | ( | dods_uint64 * | b | ) | const

virtual

Definition at line 2500 of file Vector.cc.

## value() [12/23]

void libdap::Vector::value | ( | vector< string > & | b | ) | const

virtual

Get a copy of the data held by this variable.

Definition at line 2519 of file Vector.cc.

## value() [13/23]

void libdap::Vector::value | ( | vector< unsigned int > * | index,
|  | vector< string > & | b
| ) |  | const

virtual

Get a copy of the data held by this variable using the passed subsetIndex vector to identify which values to return.

Definition at line 2448 of file Vector.cc.

## value() [14/23]

void libdap::Vector::value | ( | vector< unsigned int > * | indices,
|  | dods_byte * | b
| ) |  | const

virtual

Definition at line 2411 of file Vector.cc.

## value() [15/23]

void libdap::Vector::value | ( | vector< unsigned int > * | indices,
|  | dods_float32 * | b
| ) |  | const

virtual

Definition at line 2419 of file Vector.cc.

## value() [16/23]

void libdap::Vector::value | ( | vector< unsigned int > * | indices,
|  | dods_float64 * | b
| ) |  | const

virtual

Definition at line 2420 of file Vector.cc.

## value() [17/23]

void libdap::Vector::value | ( | vector< unsigned int > * | indices,
|  | dods_int16 * | b
| ) |  | const

virtual

Definition at line 2413 of file Vector.cc.

## value() [18/23]

void libdap::Vector::value | ( | vector< unsigned int > * | indices,
|  | dods_int32 * | b
| ) |  | const

virtual

Definition at line 2415 of file Vector.cc.

## value() [19/23]

void libdap::Vector::value | ( | vector< unsigned int > * | indices,
|  | dods_int64 * | b
| ) |  | const

virtual

Definition at line 2417 of file Vector.cc.

## value() [20/23]

void libdap::Vector::value | ( | vector< unsigned int > * | indices,
|  | dods_int8 * | b
| ) |  | const

virtual

Definition at line 2412 of file Vector.cc.

## value() [21/23]

void libdap::Vector::value | ( | vector< unsigned int > * | indices,
|  | dods_uint16 * | b
| ) |  | const

virtual

Definition at line 2414 of file Vector.cc.

## value() [22/23]

void libdap::Vector::value | ( | vector< unsigned int > * | indices,
|  | dods_uint32 * | b
| ) |  | const

virtual

Definition at line 2416 of file Vector.cc.

## value() [23/23]

void libdap::Vector::value | ( | vector< unsigned int > * | indices,
|  | dods_uint64 * | b
| ) |  | const

virtual

Definition at line 2418 of file Vector.cc.

## value_ll() [1/11]

void libdap::Vector::value_ll | ( | vector< uint64_t > * | index,
|  | vector< string > & | b
| ) |  | const

virtual

Definition at line 2466 of file Vector.cc.

## value_ll() [2/11]

void libdap::Vector::value_ll | ( | vector< uint64_t > * | indices,
|  | dods_byte * | b
| ) |  | const

virtual

Definition at line 2422 of file Vector.cc.

## value_ll() [3/11]

void libdap::Vector::value_ll | ( | vector< uint64_t > * | indices,
|  | dods_float32 * | b
| ) |  | const

virtual

Definition at line 2430 of file Vector.cc.

## value_ll() [4/11]

void libdap::Vector::value_ll | ( | vector< uint64_t > * | indices,
|  | dods_float64 * | b
| ) |  | const

virtual

Definition at line 2431 of file Vector.cc.

## value_ll() [5/11]

void libdap::Vector::value_ll | ( | vector< uint64_t > * | indices,
|  | dods_int16 * | b
| ) |  | const

virtual

Definition at line 2424 of file Vector.cc.

## value_ll() [6/11]

void libdap::Vector::value_ll | ( | vector< uint64_t > * | indices,
|  | dods_int32 * | b
| ) |  | const

virtual

Definition at line 2426 of file Vector.cc.

## value_ll() [7/11]

void libdap::Vector::value_ll | ( | vector< uint64_t > * | indices,
|  | dods_int64 * | b
| ) |  | const

virtual

Definition at line 2428 of file Vector.cc.

## value_ll() [8/11]

void libdap::Vector::value_ll | ( | vector< uint64_t > * | indices,
|  | dods_int8 * | b
| ) |  | const

virtual

Definition at line 2423 of file Vector.cc.

## value_ll() [9/11]

void libdap::Vector::value_ll | ( | vector< uint64_t > * | indices,
|  | dods_uint16 * | b
| ) |  | const

virtual

Definition at line 2425 of file Vector.cc.

## value_ll() [10/11]

void libdap::Vector::value_ll | ( | vector< uint64_t > * | indices,
|  | dods_uint32 * | b
| ) |  | const

virtual

Definition at line 2427 of file Vector.cc.

## value_ll() [11/11]

void libdap::Vector::value_ll | ( | vector< uint64_t > * | indices,
|  | dods_uint64 * | b
| ) |  | const

virtual

Definition at line 2429 of file Vector.cc.

## var() [1/3]

BaseType * libdap::Vector::var | ( | const string & | n,
|  | btp_stack & | s
| ) |  |

override virtual

This version of var(...) searches for name and returns a pointer to the BaseType object if found. It uses the same search algorithm as above when exact_match is false. In addition to returning a pointer to the variable, it pushes onto s a BaseType pointer to each constructor type that ultimately contains name.

Parameters

  n | Find the variable whose name is name.
  s | Record the path to name.

Returns
  A pointer to the named variable.

Reimplemented from libdap::BaseType.

Definition at line 520 of file Vector.cc.

## var() [2/3]

BaseType * libdap::Vector::var | ( | const string & | n = `""`,
|  | bool | exact = `true`,
|  | btp_stack * | s = `nullptr`
| ) |  |

override virtual

Returns a copy of the template array element. If the Vector contains simple data types, the template will contain the value of the last vector element accessed with the `Vector::var(int i)` function, if any. If no such access has been made, or if the Vector contains compound data types, the value held by the template instance is undefined.

Note that the parameter exact_match is not used by this mfunc.

Parameters

  n | The name of the variable to find.
  exact | Unused.
  s | Pointer to a BaseType Pointer Stack. Use this stack to record the path to the variable. By default this pointer is null, in which case it is not used.

Returns
  A pointer to the BaseType if found, otherwise null.

See also
  Vector::var

Reimplemented from libdap::BaseType.

Definition at line 486 of file Vector.cc.

## var() [3/3]

BaseType * libdap::Vector::var | ( | unsigned int | i | ) |

virtual

Returns a pointer to the specified Vector element. The return pointer will reference the element itself, so multiple calls to this method should save each value before making the next call.

Parameters

  i | The index of the desired Vector element. Zero indicates the first element of the Vector.

Returns
  A pointer to a BaseType class instance containing the value of the indicated element. The BaseType pointer is locally maintained and should not be deleted or referenced. Extract the value right after the method returns.

See also
  BaseType::var

Definition at line 584 of file Vector.cc.

## var_ll()

BaseType * libdap::Vector::var_ll | ( | uint64_t | i | ) |

virtual

Definition at line 589 of file Vector.cc.

## vec_resize()

void libdap::Vector::vec_resize | ( | int | l | ) |

Resizes a Vector. If the input length is greater than the current length of the Vector, new memory is allocated (the Vector moved if necessary), and the new entries are appended to the end of the array and padded with Null values. If the input length is shorter, the tail values are discarded.

Note
  This method is applicable to the compound types only.

Definition at line 637 of file Vector.cc.

## vec_resize_ll()

void libdap::Vector::vec_resize_ll | ( | int64_t | l | ) |

Definition at line 654 of file Vector.cc.

## width()

unsigned int libdap::Vector::width | ( | bool | constrained = `false` | ) | const

inline override virtual

Returns the width of the data, in bytes.

Returns the number of bytes needed to hold the entire array. This is equal to `length()` (the number of elements in in the array) times the width of each element.

Deprecated:
  Use width_ll() instead

Reimplemented from libdap::BaseType.

Definition at line 195 of file Vector.h.

## width_ll()

int64_t libdap::Vector::width_ll | ( | bool | constrained = `false` | ) | const

inline override virtual

Return the number of bytes needed to hold the array data.

Parameters

  constrained | If true, return the number of bytes given the current constraint

Returns
  The number of bytes needed to hold the array data, as a 64-bit integer

Reimplemented from libdap::BaseType.

Definition at line 208 of file Vector.h.

## Friends And Related Symbol Documentation

## MarshallerTest

friend class MarshallerTest

friend

Conditionally set to true in set_length_ll()

Definition at line 106 of file Vector.h.

The documentation for this class was generated from the following files:

- Vector.h
- Vector.cc